#include <sys/types.h>
#include <stdio.h>
#include <stdlib.h>
#include "gnfalib.h"

put_bytes(char **s, u_short id, int nb, char *from, int *bufLen, char **buf) 
{

	u_short *ID = (u_short *) *s;
	int lg = IDLGSZ + nb*sizeof(char);
	char *to = *s + IDLGSZ;
	int dist = *s - *buf;

	if (lg%2 != 0)
		lg++;
	if (lg >= *bufLen - dist) {
		do *bufLen += CHUNK;
		while (lg >= *bufLen - dist);
		if ((*buf = (char *) realloc(*buf, (size_t) *bufLen)) == 0 ) {
			fprintf(stderr, "couldn't realloc NADF buffer\n");
			exit(1);
		}	
		*s = *buf + dist;
		ID = (u_short *) *s;
		to = *s + IDLGSZ;
	}
	ID[0] = id;
	ID[1] = nb * sizeof(char);
	memcpy(to, from, nb*sizeof(char));
	*s += lg;
}
put_string(char **s, u_short id, char *from, int *bufLen, char **buf) 
{

	int slen = strlen(from);
	u_short *ID = (u_short *) *s;
	int lg = IDLGSZ + slen;
	char *to = *s + IDLGSZ;
	int dist = *s - *buf;

	if (lg%2 != 0)
		lg++;
	if (lg >= *bufLen - dist) {
		do *bufLen += CHUNK;
		while (lg >= *bufLen - dist);
		if ((*buf = (char *) realloc(*buf, (size_t) *bufLen)) == 0 ) {
			fprintf(stderr, "couldn't realloc NADF buffer\n");
			exit(1);
		}
		*s = *buf + dist;
		ID = (u_short *) *s;
		to = *s + IDLGSZ;
	}
	ID[0] = id;
	ID[1] = slen;
	strncpy(to, from, slen);
	*s += lg;
	return (slen + 1);
}
put_stringMulti(char **s, u_short id, int cnt, char *from, int *bufLen, char **buf) 
{

	u_short slen;
	u_short *ID = (u_short *) *s;
	char *crt;
	int dist = *s - *buf;
	char *to = *s + IDLGSZ;
	int lg;

	crt = from;
	while (cnt-1 > 0) {
		if (!*crt) {
			*crt = ':';
			cnt--;
		}
		crt++;
	}
	slen = strlen(from) + 1;
	if (slen%2)
		lg = slen +1;
	else
		lg = slen;
	if (lg >= *bufLen - dist) {
		do *bufLen += CHUNK;
		while (lg >= *bufLen - dist);
		if ((*buf = (char *) realloc(*buf, (size_t) *bufLen)) == 0) {
			fprintf(stderr, "couldn't realloc NADF buffer\n");
			exit(1);
		}
		/* restore pointers into NADF buffer */

		*s = *buf + dist;
		ID = (u_short *) *s;
		to = *s + IDLGSZ;
	}
	ID[0] = id;
	ID[1] = lg;
	strncpy(to, from, slen);
	*s += lg;
	return slen;
}
putCharMulti(char **s, u_short id, int nb, char *from, int *bufLen, char **buf) 
{

	u_short *ID = (u_short *) *s;
	int lg = IDLGSZ + nb*sizeof(char);
	char *to = *s + IDLGSZ;
	int dist = *s - *buf;

	if (lg%2 != 0)
		lg++;
	if (lg >= *bufLen - dist) {
		do *bufLen += CHUNK;
		while (lg >= *bufLen - dist);
		if ((*buf = (char *) realloc(*buf, (size_t) *bufLen)) == 0 ) {
			fprintf(stderr, "couldn't realloc NADF buffer\n");
			exit(1);
		}
		*s = *buf + dist;
		ID = (u_short *) *s;
		to = *s + IDLGSZ;
	}
	ID[0] = id;
	ID[1] = nb * sizeof(char);
	memcpy(to, from, nb*sizeof(char));
	*s += lg;
}

put_char(char **s, u_short id, int c, int *bufLen, char **buf) 
{

	u_short *IDL = (u_short *) *s;
	int lg = IDLGSZ+sizeof(u_char)+1;
	char *to = *s + IDLGSZ;
	int dist = *s - *buf;

	if (lg >= *bufLen - dist) {
		do *bufLen += CHUNK;
		while (lg >= *bufLen - dist);
		if ((*buf = (char *) realloc(*buf, (size_t) *bufLen)) == 0 ) {
			fprintf(stderr, "couldn't realloc NADF buffer\n");
			exit(1);
		}
		*s = *buf + dist;
		IDL = (u_short *) *s;
		to = *s + IDLGSZ;
	}
	IDL[0] = id;
	IDL[1] = sizeof(char);
	*((char *) &IDL[2]) = (char) c;
	*s += lg;
}

put_u_char(char **s, u_short id, u_int c, int *bufLen, char **buf) 
{

	u_short *IDL = (u_short *) *s;
	int lg = IDLGSZ+sizeof(u_char)+1;
	char *to = *s + IDLGSZ;
	int dist = *s - *buf;

	if (lg >= *bufLen - dist) {
		do *bufLen += CHUNK;
		while (lg >= *bufLen - dist);
		if ((*buf = (char *) realloc(*buf, (size_t) *bufLen)) == 0 ) {
			fprintf(stderr, "couldn't realloc NADF buffer\n");
			exit(1);
		}
		*s = *buf + dist;
		IDL = (u_short *) *s;
		to = *s + IDLGSZ;
	}
	IDL[0] = id;
	IDL[1] = sizeof(u_char);
	*((u_char *) &IDL[2]) = (u_char) c;
	*s += lg;
}

	
put_short(char **s, u_short id, short v, int *bufLen, char **buf) 
{
	u_short *IDL = (u_short *) *s;
	int lg = IDLGSZ + sizeof(short);
	int dist = *s - *buf;
	
	if (lg >= *bufLen - dist) {
		do 
			*bufLen += CHUNK;
		while (lg >= *bufLen - dist);
		if ((*buf = (char *) realloc(*buf, (size_t) *bufLen)) == 0 ) {
			fprintf(stderr, "couldn't realloc NADF buffer\n");
			exit(1);
		}
		*s = *buf + dist;
		IDL = (u_short *) *s;
	}
	IDL[0] = id;
	IDL[1] = sizeof(short);
	*((short *) &IDL[2]) = v;
	*s += lg;
}
	
put_u_short(char **s, u_short id, u_short v, int *bufLen, char **buf) 
{
	u_short *IDL = (u_short *) *s;
	int lg = IDLGSZ + sizeof(u_short);
	int dist = *s - *buf;
	
	if (lg >= *bufLen - dist) {
		do { 
			*bufLen += CHUNK;
		} while (lg >= *bufLen - dist);
		if ((*buf = (char *) realloc(*buf, (size_t) *bufLen)) == 0 ) {
			fprintf(stderr, "couldn't realloc NADF buffer\n");
			exit(1);
		}
		*s = *buf + dist;
		IDL = (u_short *) *s;
	}
	IDL[0] = id;
	IDL[1] = sizeof(short);
	IDL[2] = v;
	*s += lg;
}
	
put_int(char **s, u_short id, int v, int *bufLen, char **buf) 
{
	u_short *IDL = (u_short *) *s;
	int lg = IDLGSZ + sizeof(int);
	int dist = *s - *buf;
	
	if (lg >= *bufLen - dist) {
		do { 
			*bufLen += CHUNK;
		} while (lg >= *bufLen - dist);
		if ((*buf = (char *) realloc(*buf, (size_t) *bufLen)) == 0 ) {
			fprintf(stderr, "couldn't realloc NADF buffer\n");
			exit(1);
		}
		*s = *buf + dist;
		IDL = (u_short *) *s;
	}
	IDL[0] = id;
	IDL[1] = sizeof(int);
	printf("installing an int of value %d\n", v);
	memcpy((char *) &IDL[2], &v, sizeof(int));
	printf("int of value %d installed\n", v);
	*s += lg;
}

put_u_int(char **s, u_short id, u_int v, int *bufLen, char **buf) 
{
	u_short *IDL = (u_short *) *s;
	int lg = IDLGSZ + sizeof(u_int);
	int dist = *s - *buf;
	
	if (lg >= *bufLen - dist) {
		do { 
			*bufLen += CHUNK;
		} while (lg >= *bufLen - dist);
		if ((*buf = (char *) realloc(*buf, (size_t) *bufLen)) == 0 ) {
			fprintf(stderr, "couldn't realloc NADF buffer\n");
			exit(1);
		}
		*s = *buf + dist;
		IDL = (u_short *) *s;
	}
	IDL[0] = id;
	IDL[1] = sizeof(u_int);
	printf("installing an u_int of value %d\n", v);
	memcpy((char *) &IDL[2], &v, sizeof(u_int));
	printf("u_int of value %d installed\n", v);
	*s += lg;
}

put_long(char **s, u_short id, long v, int *bufLen, char **buf) 
{
	u_short *IDL = (u_short *) *s;
	int lg = IDLGSZ + sizeof(long);
	int dist = *s - *buf;
	
	if (lg >= *bufLen - dist) {
		do { 
			*bufLen += CHUNK;
		} while (lg >= *bufLen - dist);
		if ((*buf = (char *) realloc(*buf, (size_t) *bufLen)) == 0 ) {
			fprintf(stderr, "couldn't realloc NADF buffer\n");
			exit(1);
		}
		*s = *buf + dist;
		IDL = (u_short *) *s;
	}
	IDL[0] = id;
	IDL[1] = sizeof(long);
	memcpy((char *) &IDL[2], &v, sizeof(long));
	*s += lg;
}
put_u_long(char **s, u_short id, u_long v, int *bufLen, char **buf) 
{
	u_short *IDL = (u_short *) *s;
	int lg = IDLGSZ + sizeof(u_long);
	int dist = *s - *buf;
	
	if (lg >= *bufLen - dist) {
		do { 
			*bufLen += CHUNK;
		} while (lg >= *bufLen - dist);
		if ((*buf = (char *) realloc(*buf, (size_t) *bufLen)) == 0 ) {
			fprintf(stderr, "couldn't realloc NADF buffer\n");
			exit(1);
		}
		*s = *buf + dist;
		IDL = (u_short *) *s;
	}
	IDL[0] = id;
	IDL[1] = sizeof(u_long);
	memcpy((char *) &IDL[2], &v, sizeof(u_long));
	*s += lg;
}
put_float(char **s, u_short id, float v, int *bufLen, char **buf) 
{
	u_short *IDL = (u_short *) *s;
	int lg = IDLGSZ + sizeof(float);
	int dist = *s - *buf;
	
	if (lg >= *bufLen - dist) {
		do { 
			*bufLen += CHUNK;
		} while (lg >= *bufLen - dist);
		if ((*buf = (char *) realloc(*buf, (size_t) *bufLen)) == 0 ) {
			fprintf(stderr, "couldn't realloc NADF buffer\n");
			exit(1);
		}
		*s = *buf + dist;
		IDL = (u_short *) *s;
	}
	IDL[0] = id;
	IDL[1] = sizeof(float);
	memcpy((char *) &IDL[2], &v, sizeof(float));
	*s += lg;
}

put_double(char **s, u_short id, double v, int *bufLen, char **buf) 
{
	u_short *IDL = (u_short *) *s;
	int lg = 2 * sizeof(u_short) + sizeof(double);
	int dist = *s - *buf;
	
	if (lg >= *bufLen - dist) {
		do { 
			*bufLen += CHUNK;
		} while (lg >= *bufLen - dist);
		if ((*buf = (char *) realloc(*buf, (size_t) *bufLen)) == 0 ) {
			fprintf(stderr, "couldn't realloc NADF buffer\n");
			exit(1);
		}
		*s = *buf + dist;
		IDL = (u_short *) *s;
	}
	IDL[0] = id;
	IDL[1] = sizeof(double);
	memcpy((char *) &IDL[2], &v, sizeof(float));
	*s += lg;
}
